routes/web.php
<?php

use App\Http\Controllers\Admin;
use App\Http\Controllers\Supplier;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\POSController;
use App\Http\Controllers\SiteController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\OrderController;
use App\Http\Controllers\Admin\StockController;
use App\Http\Controllers\Admin\PurchaseController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [SiteController::class, 'index'])->name('index');
Route::get('/home', [SiteController::class, 'home'])
    ->name('home')
    ->middleware('auth');
Route::get('/404', [SiteController::class, 'notFound'])->name('404');

Route::controller(POSController::class)
    ->middleware('cashier')
    ->prefix('/pos')
    ->name('pos.')
    ->group(function () {
        Route::get('/', 'index')->name('index');
        Route::post('/select-customer', 'selectCustomer')->name('customer.select');
        Route::post('/new-customer', 'createCustomer')->name('customer.create');
        Route::post('/no-customer', 'emptyCustomer')->name('customer.none');

        Route::get('/order/{order}', 'order')->name('order');
        Route::post('/order/{order}/status', 'changeStatus')->name('status');
        Route::post('/order/{order}/products', 'addProduct')->name('products.store');
        Route::get('/order/{order}/{product_order}/delete', 'deleteProduct')->name('products.delete');
        Route::post('/order/{order}/quantity', 'updateQuantity')->name('quantity');
    });

Route::middleware(['auth', 'admin'])->prefix('/admin')->name('admin.')->group(function () {
    Route::get('/', [Admin\AdminController::class, 'index'])->name('index');

    //CRUD
    Route::resource('categories', Admin\CategoryController::class);
    Route::resource('suppliers', Admin\SupplierController::class);
    Route::resource('customers', Admin\CustomerController::class);

    Route::controller(Admin\ProductController::class)->name('products.')->group(function () {
        Route::get('products/{product}/variants', 'variants')->name('variants');
        Route::post('products/{product}/variants', 'addVariant')->name('variants');
        Route::delete('products/{product}/variants/{variant}', 'removeVariant')->name('variants.delete');
        Route::get('products/search', 'search')->name('search');
    });

    Route::resource('products', Admin\ProductController::class);
    Route::get('batches/{batch}/products', [Admin\BatchController::class, 'products'])->name('batches.products.index');
    Route::post('batches/{batch}/products', [Admin\BatchController::class, 'addProduct'])->name('batches.products.store');
    Route::delete('batches/{batch}/products/{batchproduct}', [Admin\BatchController::class, 'deleteProduct'])->name('batches.products.destory');
    Route::resource('batches', Admin\BatchController::class);
    Route::resource('batchproducts', Admin\BatchProductController::class);
    Route::resource('stocks', Admin\StockController::class);

    Route::get('purchases/supplies', [Admin\PurchaseController::class, 'supplies'])->name('purchases.supplies.index');
    Route::get('purchases/{purchase}/approve', [Admin\PurchaseController::class, 'approve'])->name('purchases.supplies.approve');
    Route::delete('purchases/{purchase}/decline', [Admin\PurchaseController::class, 'decline'])->name('purchases.supplies.decline');
    Route::resource('purchases', Admin\PurchaseController::class);

    Route::resource('users', Admin\UserController::class);
    Route::prefix('orders')->name('orders.')->controller(Admin\OrderController::class)->group(function () {
        Route::post('{order}/status', 'changeStatus')->name('status');
        Route::post('{order}/products', 'addProduct')->name('products.store');
        Route::get('{order}/{product_order}/quantity', 'editQuantity')->name('products.quantity');
        Route::post('{order}/{product_order}/quantity', 'updateQuantity');
        Route::get('{order}/{product_order}/delete', 'deleteProduct')->name('products.delete');
    });
    Route::resource('orders', Admin\OrderController::class);

    Route::get('/reports', [Admin\ReportController::class, 'index'])->name('reports.index');
    Route::get('/reports/view', [Admin\ReportController::class, 'view'])->name('reports.view');
});


Route::middleware(['auth', 'supplier'])->prefix('/supplier')->name('supplier.')->group(function () {
    Route::get('/', [Supplier\SupplierController::class, 'index'])->name('index');


    //CRUD
    Route::controller(Supplier\ProductController::class)->name('products.')->group(function () {
        Route::get('products/{product}/variants', 'variants')->name('variants');
        Route::post('products/{product}/variants', 'addVariant')->name('variants');
        Route::delete('products/{product}/variants/{variant}', 'removeVariant')->name('variants.delete');
        Route::get('products/search', 'search')->name('search');
    });
    Route::resource('products', Supplier\ProductController::class);
    Route::resource('purchases', Supplier\PurchaseController::class);
    Route::resource('suppliers', SupplierController::class);
    Route::resource('variants', \App\Http\Controllers\Supplier\ProductController::class);
    // Route::resource('customers', CustomerController::class);
    // Route::resource('products', ProductController::class);
    // Route::resource('variants', VariantController::class);
});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;

    protected $fillable = ['name'];

    public function products()
    {
        return $this->hasMany(Product::class);
    }
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Category;
use Illuminate\Http\Request;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = Category::simplePaginate(5);

        return view('admin.categories.index', compact('categories'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.categories.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => ['required', 'unique:categories,name'],
        ]);

        Category::create([
            'name' => $request->name,
        ]);

        return redirect()->route('admin.categories.index')
            ->with('success', 'Category Created Successfully!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function show(Category $category)
    {
        return view('admin.categories.show', compact('category'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function edit(Category $category)
    {
        return view('admin.categories.edit', compact('category'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Category $category)
    {
        $request->validate([
            'name' => ['required'],
        ]);

        $category->update([
            'name' => $request->name,
        ]);

        return redirect()->route('admin.categories.index')
            ->with('success', 'Category Updated Successfully!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {

        $category->delete();

        return redirect()->route('admin.categories.index')
            ->with('success', 'Category Deleted Successfully!');
    }
}

resources/views/admin/categories/create.blade.php
@extends('adminlte::page')

@section('title', 'Add New Category')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            Add New Category
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.categories.index') }}"> <i class="fas fa-arrow-circle-left mr-2"></i>Go Back</a>
        </div>

    </div>

      <div class="card-body">
          <form action="{{ route('admin.categories.store') }}" method="post">
            @csrf

            <div class="form-group">
                <label for="name">Category Name</label>
                <input type="text" name="name" id="name" class="form-control">
            </div>

            <button class="btn btn-outline-secondary">
                <i class="fas fa-save mr-2"></i>
                Save
            </button>
          </form>
      </div>

</div>

@endsection

resources/views/admin/categories/edit.blade.php
@extends('adminlte::page')

@section('title', 'Edit Category')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            Edit Category
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.categories.index') }}"> 
                <i class="fas fa-arrow-circle-left mr-2"></i>
                Go Back
            </a>
        </div>

    </div>

      <div class="card-body">
          <form action="{{ route('admin.categories.update', $category) }}" method="post">
            @csrf
            @method('PUT')

            <div class="form-group">
                <label for="name">Category Name</label>
                <input type="text" name="name" id="name" class="form-control" value="{{ $category->name }}">
            </div>

            <button class="btn btn-outline-secondary">
                <i class="fas fa-save mr-2"></i>
                Save
            </button>
          </form>
      </div>

</div>

@endsection

resources/views/admin/categories/index.blade.php
@extends('adminlte::page')

@section('title', 'All Categories')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            All Categories
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.categories.create') }}"> <i class="fas fa-plus-circle mr-2"></i>Add New</a>
        </div>

    </div>

      <div class="card-body p-0">
          <table class="table table-bordered table-striped">
              <thead class="bg-secondary">
                  <tr>
                      <th>ID</th>
                      <th>Name</th>
                      <th>Date</th>
                      <th>Action</th>
                  </tr>
              </thead>

              <tbody>
                  @foreach ($categories as $category)
                  <tr>
                      <td>{{ $category->id }}</td>
                      <td>{{ $category->name }}</td>
                      <td>{{ $category->created_at }}</td>
                      <td>
                          <a class="btn btn-outline-secondary btn-sm" href="{{ route('admin.categories.show', $category) }}">
                           
                            <i class="fas fa-eye mr-2"></i>
                            Details

                           </a>
                           <a class="btn btn-outline-secondary btn-sm" href="{{ route('admin.categories.edit', $category) }}">
                           
                            <i class="fas fa-edit mr-2"></i>
                            Edit

                           </a>

                           <form style="display: inline-block" action="{{ route('admin.categories.destroy', $category) }}" method="post">
                              @csrf
                              @method('DELETE')

                              <button class="btn btn-outline-danger btn-sm">
                                  <i class="fas fa-trash mr-2"></i>
                                  Delete
                              </button>
                          </form>
                      </td>
                  </tr>
                      
                  @endforeach
              </tbody>
          </table>

          @if(count($categories) == 0)
          <div class="alert alert-warning text-center mb-0">
              No Items Found!
          </div>
          @endif

        </div>
        
        <div class="card-footer">
          {{ $categories->links() }}
      </div>

</div>

@endsection

resources/views/admin/categories/show.blade.php
@extends('adminlte::page')

@section('title', 'Category Details')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            Category Details
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.categories.index') }}"> 
                <i class="fas fa-arrow-circle-left mr-2"></i>
                Go Back
            </a>
        </div>

    </div>

      <div class="card-body p-0">
          <table class="table table-bordered table-striped">
              <tr>
                  <th style="width: 20%">ID</th>
                  <td>{{ $category->id }}</td>

              </tr>
              <tr>
                <th>Name</th>
                <td>{{ $category->name }}</td>
                
            </tr>
            <tr>
                <th>Created</th>
                <td>{{ $category->created_at }}</td>
                
            </tr>
            <tr>
                <th>Updated</th>
                <td>{{ $category->updated_at }}</td>
                
            </tr>
          </table>
          
      </div>

</div>

@endsection